% Constants
simulationDataPath = 'G:\eclipse\eclipse\ganymede\workspace\XTeamSimulator';
modelFilePath = 'F:\Documents and Settings\Administrator\Desktop\RESIST\ConfigurationReliabilityAnalyzer\initial_estimations';

% Read the simulation data
controllerData1 = dlmread([simulationDataPath '\Robot5_Controller.txt']);
navigatorData1 = dlmread([simulationDataPath '\Robot5_Navigator1_Controller.txt']);
navigatorData2 = dlmread([simulationDataPath '\Robot5_Navigator2_Controller.txt']);

% Calculate Each Component's Reliability
PDA_Out = 1;
TS1 = 1;
TS2 = 1;
C = calculateComponentReliability_controller(controllerData1, [1,0,0,0,0], [modelFilePath '\Controller' ]);
HS1 = 1;
HS2 = 1; 
PS1 = 1; 
PS2 = 1;
FT = 1;
N1 = calculateComponentReliability_navigator(navigatorData1, [1,0,0,0], [modelFilePath '\Navigator1' ]);
N2 = calculateComponentReliability_navigator(navigatorData2, [1,0,0,0], [modelFilePath '\Navigator2' ]);
A = 1;
PDA_In = 1;

% Calculate System Reliability

% S1 : PDA_Out
% S2 : TS1
% S3 : TS2
% S4 : C
% S5 : HS1, HS2, PS1, PS2
% S6 : FT
% S7 : N1, N2
% S8 : A
% S9 : PDA_In

% Calculate transition probabilities
P14 = 1;
P24 = 1;
P34 = 1;

[P45, P46, P48, P49] = transitionProbability_controller(controllerData1);

P67 = 0.5;
P64 = 0.5;

P54 = 1;
P84 = 1;


% M
S1_S4 = PDA_Out*P14;
S2_S4 = TS1*P24;
S3_S4 = TS2*P34;

S4_S5 = C*P45;
S5_S4 = HS1*HS2*PS1*PS2*P54;

S4_S6 = C*P46;
S6_S4 = FT*P64;

S6_S7 = FT*P67;
S7_S6 = 1 - ((1-N1)*(1-N2))

S4_S8 = C*P48;
S8_S4 = A*P84;

S4_S9 = C*P49;

M   =   [   0       0       0       S1_S4   0       0       0       0       0     
            0       0       0       S2_S4   0       0       0       0       0
            0       0       0       S3_S4   0       0       0       0       0
            0       0       0       0       S4_S5   S4_S6   0       S4_S8   S4_S9
            0       0       0       S5_S4   0       0       0       0       0
            0       0       0       S6_S4   0       0       S6_S7   0       0
            0       0       0       0       0       S7_S6   0       0       0
            0       0       0       S8_S4   0       0       0       0       0
            0       0       0       0       0       0       0       0       0       ]


IM = eye(9,9) - M;
DET_IM = det(IM);


E = IM(1:8,2:9);
DET_E = det(E);

C
N1
N2

systemReliability = (-1)^10 * PDA_In * (DET_E / DET_IM)

observedReliability = calculateObservedReliability_system(controllerData1)