function [componentReliability] = calculateComponentReliability(data, initial, modelDataFilePath)

addpath(genpath('G:\Deshan\Research\HMMMatlab\HMM\HMMall'));

% Trim the data in to a matrix
rows = size(data,1);
columns = size(data,2);
x = columns;
for i = 1 : rows
    for j = 1 : columns
        if ((data(i,j) == 0) & (j <= x))
            x = j-1;
            break
        end
    end
end
data = data(1:rows , 1:x);

% Initial guess of parameters
prior1 = initial;

% Read initial probabilities
transitionProbabilityInputFile = [modelDataFilePath '\inputToMatlab\transitionProbabilities.txt'];
observationProbabilityInputFile = [modelDataFilePath '\inputToMatlab\observationProbabilities.txt'];
% Initial Transition Matrix
transmat1 = dlmread(transitionProbabilityInputFile);
% Initial Observation Matrix
obsmat1 = dlmread(observationProbabilityInputFile);


for j=1:1
    % Improve guess of parameters using EM
    [LL, prior2, transmat2, obsmat2] = dhmm_em(data, prior1, transmat1, obsmat1, 'max_iter', 100);
    p_power = fixdec(transmat2^10000,5);
    transmat2
    steady_st_v = unique(p_power, 'rows')
    ss = size (steady_st_v);
    if (ss(1,1) ==1)
        result(j) = 1 - steady_st_v(5);
        result(j)
    end
end

transmat2
steady_st_v
componentReliability = mean(result);
